<script lang="ts" setup>
import { ref } from 'vue';
import SearchIcon from '~/assets/icons/search.vue';
import type { BaseLink } from '@/types/base';

/**
 * Component that receives an array of suggestions that is fetched in the SearchContent component
 * If the suggestions array is empty, the component will show some default searchTerms
 * After a suggestion is selected, it will be passed to the parent component to do the search
 */

// Props
const props = defineProps<{
  searchSuggestions?: Array<{ title: string }>;
  text?: string;
  default?: BaseLink[];
}>();

// Emits
const emit = defineEmits<{
  (e: 'suggestionSelect', suggestion: string): void;
}>();

// Reactive data
const isMobile = ref(false);
const defaultSuggestions = ref(props?.default);

// Methods
const onSelectSuggestion = (suggestion: string) => {
  emit('suggestionSelect', suggestion);
};
</script>

<template>
  <div class="be-nav-suggestions">
    <SlpTypography tag="span" variant="body1" class="slp-mb-24"> {{ props?.text }} </SlpTypography>
    <div v-if="!props?.searchSuggestions?.length && !isMobile" class="be-nav-suggestions__default">
      <SlpButton
        v-for="(suggestion, index) in defaultSuggestions"
        :key="`${suggestion.text}-${index}`"
        class="be-nav-suggestions__default-btn"
        :href="suggestion.config.href"
        :data-ga-name="suggestion.config.dataGaName"
        :data-ga-location="suggestion.config.dataGaLocation"
        target="_blank"
        @click="!suggestion.config.href ? onSelectSuggestion(suggestion.text) : () => {}"
      >
        {{ suggestion.text }}
      </SlpButton>
    </div>
    <div v-if="!props?.searchSuggestions?.length && isMobile">
      <div v-for="suggestion in defaultSuggestions" :key="suggestion.text" class="be-nav-suggestions__result">
        <div class="be-nav-suggestions__result--icon">
          <SearchIcon fill="#171321" />
        </div>
        <SlpButton
          variant="tertiary"
          :data-ga-name="suggestion.text"
          data-ga-location="search"
          @click="onSelectSuggestion(suggestion.text)"
        >
          <span>{{ suggestion.text }}</span>
        </SlpButton>
      </div>
    </div>
    <div v-else>
      <div
        v-for="(suggestion, index) in props.searchSuggestions"
        :key="`${suggestion.title}-${index}`"
        class="be-nav-suggestions__result"
      >
        <div class="be-nav-suggestions__result--icon">
          <SearchIcon fill="#171321" />
        </div>
        <SlpButton
          variant="tertiary"
          :data-ga-name="suggestion.title"
          data-ga-location="search"
          @click="onSelectSuggestion(suggestion.title)"
        >
          <span>{{ suggestion.title }}</span>
        </SlpButton>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.be-nav-suggestions {
  &__default {
    margin-top: 4px;
    display: flex;
    justify-content: space-between;
    flex-wrap: wrap;

    @media (min-width: $breakpoint-lg) {
      display: grid;
      column-gap: 32px;
      grid-template-columns: repeat(2, 1fr);
    }
    @media (min-width: $breakpoint-xl) {
      grid-template-columns: repeat(3, 1fr);
    }
    @media (max-width: $breakpoint-md) {
      width: 100%;
    }
  }

  &__default-btn {
    width: 100%;
    margin-bottom: $spacing-16;
    background-color: $color-surface-800 !important;
    color: $color-text-300 !important;
    border: none !important;
    justify-content: center;
    transition: all 0.3s ease-in-out;

    @media (max-width: $breakpoint-lg) {
      max-width: 100%;
    }

    &:hover {
      background-color: #e3d6ff !important;
    }
  }

  &__result {
    display: flex;
    align-items: center;

    &--icon {
      min-width: 16px;

      svg {
        min-height: 16px;
        min-width: 16px;
      }
    }

    .slp-btn {
      color: $color-text-link-100;
      font-weight: 400;

      &:hover {
        text-decoration-color: $color-text-link-100;
      }

      @media (max-width: $breakpoint-md) {
        padding-left: 8px !important;
      }

      span {
        overflow: hidden;
        white-space: nowrap;
        text-overflow: ellipsis;
      }
    }
  }
}
</style>
